Bug 530719 - (CVE-2009-3639) CVE-2009-3639 ProFTPD: Doesn't properly handle NULL character in subjectAltName
CVE-2009-3639 ProFTPD: Doesn't properly handle NULL character in subjectAltName
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
low Severity low
: ---
: ---
Assigned To: Red Hat Product Security
http://bugs.proftpd.org/show_bug.cgi?...
impact=low,source=osssecurity,reporte...
: Security
Depends On: 537899 537900
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-24 09:30 EDT by Jan Lieskovsky
Modified: 2015-08-22 10:50 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-08-22 10:50:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jan Lieskovsky 2009-10-24 09:30:11 EDT
mod_tls.c in ProFTPD 1.3.2a does not properly handle a '\0' character
in a domain name in the subject's alternative name (subjectAltName)
field of an X.509 certificate, which allows man-in-the-middle attackers
to spoof arbitrary SSL servers via a crafted certificate issued by
a legitimate Certification Authority, a related issue to CVE-2009-2408.

Upstream bug report:
--------------------
http://bugs.proftpd.org/show_bug.cgi?id=3275

Upstream patch:
---------------
http://bugs.proftpd.org/attachment.cgi?id=3096
Comment 1 Jan Lieskovsky 2009-10-24 09:34:00 EDT
This issue affects the versions of the ProFTPD package, as shipped
with Fedora releases of 10 and 11 (proftpd-1.3.2a-5.fc{10,11}), 
and as shipped within Extra Packages for Enterprise Linux 4 and 5
(EPEL-4, EPEL-5) projects (proftpd-1.3.2a-5.el{4,5}). 

Please fix.

This issue does NOT affect the versions of the ProFTPD package,
as scheduled to appear in Fedora release of 12 and 13 
(proftpd-1.3.2b-1.fc12 and proftpd-1.3.2b-1.fc13) - these are
already fixed.
Comment 2 Tomas Hoger 2009-10-26 04:46:47 EDT
I'd say impact of this flaw should be pretty low.

Reading the upstream bug, this problem occurs when ProFTPD's mod_tls is configured to check subjectAltName in _client's_ certificates against _client's_ IP/hostname (client IP address is resolved to hostname and that hostname is resolved back to IP, if you can get to the same IP (basic sanity check), hostname is compared to the subjectAltName in the certificate).  I'm not aware of any other SSL server doing a check like this, as this is a bit strange feature.  SSL server certificate checks are used to make sure you're talking to the right server making sure you can't get tricked by malicious / owned DNS.  This check, however, relies on security of DNS...

So as far as I can see, this can be used by client to bypass intended source host name restriction.  Attacker needs to have a valid client certificate that is accepted by ProFTPD, with specially crafted sAN what would allow him to connect from other host than intended.

So rather limited impact, and probably not very often used check / restriction.
Comment 4 Fedora Update System 2009-11-16 15:54:20 EST
proftpd-1.3.2b-1.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/proftpd-1.3.2b-1.fc11
Comment 5 Fedora Update System 2009-11-16 15:56:42 EST
proftpd-1.3.2b-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/proftpd-1.3.2b-1.fc10
Comment 6 Fedora Update System 2009-11-16 15:59:38 EST
proftpd-1.3.2b-1.el5 has been submitted as an update for Fedora EPEL 5.
http://admin.fedoraproject.org/updates/proftpd-1.3.2b-1.el5
Comment 7 Fedora Update System 2009-11-16 16:00:48 EST
proftpd-1.3.2b-1.el4 has been submitted as an update for Fedora EPEL 4.
http://admin.fedoraproject.org/updates/proftpd-1.3.2b-1.el4
Comment 8 Fedora Update System 2009-11-18 09:08:06 EST
proftpd-1.3.2b-1.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 9 Fedora Update System 2009-11-18 09:10:27 EST
proftpd-1.3.2b-1.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 Fedora Update System 2009-11-18 15:21:24 EST
proftpd-1.3.2b-1.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2009-11-18 15:21:56 EST
proftpd-1.3.2b-1.el4 has been pushed to the Fedora EPEL 4 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.